<?php class shipmentdestination extends baseobject { 
	
	protected static $fields=array(
		'name'=>validator::REQUIRED,
	    'shipmenthandler'=>validator::ANY,
	    'baseuri'=>validator::ANY
	);
	
	protected static $helpTexts=array(
		'name'=>'The name of the shipment destination',
	    'shipmenthandler'=>'Name of the Javascript shipment handler object',
	    'baseuri'=>'Base URI of synchrotron API'
	);
	
	public static function create($request=array()){
	    if(!static::canCreate()){ throw new ForbiddenException('You cannot create shipment destinations'); }
	    $request['projectid']=project::getSharedProjectId();
	    parent::create($request, 'shipmentdestination');
	}
	
	public static function canCreate(){
		if(session::isAdmin()){ return true; }
		$grp=usergroup::getByName(usergroup::SHIPPERS);
		if(usergroup::userisingroup($grp['id'])){ return true; }
		$grp=usergroup::getByName(usergroup::TECHNICIANS);
		return usergroup::userisingroup($grp['id']);
	}
	
	public static function getshipments($id, $request=array()){
	    return shipment::getByProperty('shipmentdestinationid', $id, $request);
	}
	
}
